/*
 * Calibration.c
 *
 * Created: 12.06.2012 12:21:44
 *  Author: maticpi
 */ 

#include "calibration.h"

//function for calibration of the minimum and maximum levels
void Calibration()
{
	char step=1;		//Start with calibration step 1
	int min=0, max=0;
	char key;
	char OK=0;
	int ADval;
	
	while(1)
	{
		while (!MF10ms); //block for 10ms (for keyboard de-bounce)
		Clr10msFlag
		readKYB();						//Read keyboard
		key=getKEY();					//get key
		if (step<=1)					//calibration step 1
		{
			if (key != 1)				//if T1 not pressed
			{							//   refresh display 
				LCD_Clear();
				ADval=AD_convert();
				printf_P(PSTR("Cal.stp 1 (%04d)Set min, press 1"),ADval);
			}
			else						//if T1 pressed, 
			{
				min=AD_convert();		//   save min value
				step=2;					//   and continue to next step
			}			
		}
		else if (step==2)				//calibration step 2
		{
			if (key != 1)				//if T1 not pressed 
			{							//   refresh display
				LCD_Clear();
				ADval=AD_convert();
				printf_P(PSTR("Cal.stp 2 (%04d)Set max, press 1"),ADval);
			}
			else						//if T1 pressed
			{							
				max=AD_convert();		//   save max value
				if (min < max)			//   check validity of recorded values
				{						//   and display appropriate message
					LCD_Clear();
					printf_P(PSTR("Done! Save?\r\n1-Yes 2,3,4-No"));
					OK=1;
				}
				else
				{
					LCD_Clear();
					printf_P(PSTR("Failed! Repeat?\r\n1-Yes 2,3,4-No"));
					OK=0;
				}
				step++;					//   continue to next step
			}
		}
		else if (step == 3)				//calibration step 3
		{
			if (key == 1)				
			{
				if (OK)					//If values are OK, and T1 pressed
				{						//save data to EEPROM
					LCD_Clear();
					printf_P(PSTR("     Saved!"));
					bEmpty=min;
					bFull=max;
					bSpan=max-min;
					SavetoEEPROM();
					_delay_ms(2000);
					LCD_Clear();
					break;
				}
				else					//If values NOT OK, and T1 pressed
				{
					step=1;				//   restart calibration
				}
			}
			else if (key >= 2 && key <= 4 && step == 3) //if any other key pressed, exit (and don't save anything)
			{
				LCD_Clear();
				break;
			}
		}
	}
}
