/*
 * Init.c
 *
 * Created: 12.06.2012 12:28:30
 *  Author: maticpi
 */ 

#include "init.h"

//inicializacija mikrokrmilnika - se klie na zaetku funkcije main
void Init()
{
	//inicializacija
	// 1-izhod, 0-vhod
	//7654 3210
	PORTA=0xfb;  //1111 1011
	PORTB=0x00;  //0000 0000
	PORTC=0xff;  //1111 1111
	PORTD=0x7c;  //0111 1100
	DDRA=0x00;   //0000 0000
	DDRB=0xff;   //1111 1111
	DDRC=0x00;   //0000 0000
	DDRD=0x82;   //1000 0010
	
	//incializacija timer 1 - prekinitev na 1 ms
	TCCR1A=0x00;
	OCR1A=18-1;  // 18432000/1024/1000-1
	TIMSK1=(1<<OCIE1A); //omogoi prekinitve
	TIFR1=(1<<OCF1A); //zbrisi zastavice
	TCCR1B=(0<<WGM13) | (1<<WGM12) | (5<<CS10); // CTC (OCR1A) mode,  in clk/1024
	
	//Init AD
	ADMUX=(1<<REFS0) | (0<<ADLAR) |(2<<MUX0);	//Referenca: Vcc, kanal 2 (PA2)
	ADCSRA=(1<<ADEN) | (7<<ADPS0);				//Vkljui AD, Prescaller:
	DIDR0=7;
	
	//Init RS232
	#define BAUD 115200
	#include <util/setbaud.h>
	UBRR0H = UBRRH_VALUE;
	UBRR0L = UBRRL_VALUE;
	#if USE_2X
	UCSR0A |= (1 << U2X0);
	#else
	UCSR0A &= ~(1 << U2X0);
	#endif
	UCSR0C=(3<<UCSZ00);				//
	UCSR0B=(1<<RXEN0)|(1<<TXEN0);

	sei(); //Vkljui vse prekinitve
}
