/*
 * main.h
 *
 * Created: 12.06.2012 12:17:16
 *  Author: maticpi
 */ 


#ifndef MAIN_H_
#define MAIN_H_

#define F_CPU 18432000UL   // dolocitev frekvence oscilatorja za funkcije iz delay.h - mora biti pred #include <util/delay.h>
#include <avr/io.h>               //knjiznica z definicijami registrov
#include <util/delay.h>           //knjiznica s funkcijami delay
#include <avr/interrupt.h> //knjiznica z definicijami prekinitvenih vektorjev
#include <avr/pgmspace.h>
#include <avr/eeprom.h>
#include <stdio.h>
#include <math.h>
#include "lcd.h"
#include "calibration.h"
#include "rs232.h"
#include "init.h"
#include "misc.h"
#include "menus.h"

volatile long mstick;    //spremenljivka, ki teje milisekunde

volatile unsigned char MyFLAGS; // splona spremenljivka, ki vsebuje razne zastavice: bit 0 - se postavi na 1 vsakih 10 ms, bit 1 - izkljui alarm, ...
#define MF10ms			(MyFLAGS&0x01)
#define Set10msFlag		MyFLAGS|=0x01;
#define Clr10msFlag		MyFLAGS&=~0x01;
#define MFmuteAlarm		(MyFLAGS&0x02)
#define SetMuteAlarm	MyFLAGS|=0x02;
#define ClrMuteAlarm	MyFLAGS&=~0x02;
#define MFAlarmLow		(MyFLAGS&0x04)
#define SetAlarmLow		MyFLAGS|=0x04;
#define ClrAlarmLow		MyFLAGS&=~0x04;
#define MFAlarmHigh		(MyFLAGS&0x08)
#define SetAlarmHigh	MyFLAGS|=0x08;
#define ClrAlarmHigh	MyFLAGS&=~0x08;

int LowAlarmLevel;
int HighAlarmLevel;
int Hysteresis;
int bEmpty;
int bFull;
int bSpan;


#endif /* MAIN_H_ */