/*
 * Misc.c
 *
 * Created: 12.06.2012 12:22:34
 *  Author: maticpi
 */ 

#include "misc.h"

int AD_convert()
{
	ADCSRA|=(1<<ADSC);
	while (ADCSRA&(1<<ADSC));
	return ADC;
}

//funckija, ki bere stanje tipk
// tipke se nahajajo na PD2 do PD6
// funkcijo kliemo v main na vsakih xx ms
void readKYB()
{
	unsigned char ns; //novo stanje tipk
	static unsigned char ss=0xFF;     //staro stanje tipk - statina spremenljivka
	ns=PIND;     //shrani novo stanje tipk
	
	if (!(ns&0x04) && (ss&0x04 )) lastkey=1; // detektiraj prehod iz 1 -> 0
	if (!(ns&0x08) && (ss&0x08 )) lastkey=2;
	if (!(ns&0x10) && (ss&0x10 )) lastkey=3;
	if (!(ns&0x20) && (ss&0x20 )) lastkey=4;
	ss=ns;
}


// funkcija vrne zadnjo pritisnjeno tipko
unsigned char getKEY()
{
	unsigned char temp;
	temp=lastkey;
	lastkey=0;
	return temp;
}

void SavetoEEPROM()
{
	eeprom_update_word((uint16_t *)2, LowAlarmLevel);
	eeprom_update_word((uint16_t *)4, HighAlarmLevel);
	eeprom_update_word((uint16_t *)6, Hysteresis);
	eeprom_update_word((uint16_t *)8, bEmpty);
	eeprom_update_word((uint16_t *)10, bFull);
	eeprom_update_word((uint16_t *)0, 0xDEAD);	//My EEPROM signature (so I know there is valid data stored in the EEPROM)
}

void ReadFromEEPROM()
{
	if (eeprom_read_word((uint16_t *)0) == 0xDEAD)	//Is my EEPROM signature present?
	{
		LowAlarmLevel=eeprom_read_word((uint16_t *)2 );
		HighAlarmLevel=eeprom_read_word((uint16_t *)4 );
		Hysteresis=eeprom_read_word((uint16_t *)6 );
		bEmpty=eeprom_read_word((uint16_t *)8 );
		bFull=eeprom_read_word((uint16_t *)10 );
		//Make sure values are valid
		if (Hysteresis < 0) Hysteresis=0;
		if (Hysteresis > 100) Hysteresis=100;
		if (LowAlarmLevel<0) LowAlarmLevel=0;
		if (LowAlarmLevel+Hysteresis > 100) LowAlarmLevel=100-Hysteresis;
		if (HighAlarmLevel>100) HighAlarmLevel=100;
		if (HighAlarmLevel-Hysteresis<0) HighAlarmLevel=Hysteresis;
		if (bEmpty<0) bEmpty=0;
		if (bEmpty>1022) bEmpty=1022;
		if (bFull<=bEmpty) bFull=bEmpty+1;
		if (bFull > 1023) bFull=1023;
		bSpan=bFull-bEmpty;
	}
}
