/*
 * RS232.c
 *
 * Created: 12.06.2012 12:20:29
 *  Author: maticpi
 */ 
#include "RS232.h"

FILE RS232str=FDEV_SETUP_STREAM(RS232putc, NULL, _FDEV_SETUP_WRITE);

int RS232putc(char c, FILE* stream)
{
	while (!(UCSR0A&(1<<UDRE0)));
	UDR0=c;
	return 0;
}

void RefreshRS232(int level)
{
	int i;
	char bar[41];
	int lvl;
	char n40;
	
	lvl=level-bEmpty;
	if (lvl<0) lvl=0;
	if (lvl>bSpan) lvl=bSpan;
	n40=((lvl+bSpan/80)*40L)/bSpan;

	fprintf_P(&RS232str,PSTR("\rRaw AD value: %4d, Barrel %3d%% full. "),level, (lvl+bSpan/200)*100L/bSpan );
	for (i=0; i<n40; i++) bar[i]=255;
	for (; i<40; i++) bar[i]=' ';
	bar[40]=0;
	fprintf(&RS232str,bar);
}

void ReadRS232()
{
	char c;
	if (UCSR0A & (1<<RXC0))
	{
		c=UDR0;
		if (c >= '0' && c <='8')
		{
			if (MFmuteAlarm || (!MFAlarmHigh && !MFAlarmLow))	//Only if alarm is NOT active
			{
				if (c=='0')	PORTB=0;
				else PORTB = 1<<(c-'1');
			}
		}
		else if (c == 's') SettingsMenu();
	}
}

int ReadRS232value()
{
	char c;
	int value=0;
	do
	{
	while (!(UCSR0A & (1<<RXC0))) {}	//wait for a character
	c=UDR0;
	if (c >= '0' && c <= '9')
	{
		value*=10;
		value+=c-'0';
		RS232putc(c,&RS232str);	//echo - so the user can see what he/she is typing
	}
} while (c != 13 /*enter*/ && c != 27 /*ESC*/ && c != 'x');
if (c == 27 || c == 'x') value=-1;
return value;
}

